\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{pjab}
  [2021/08/19 v1.0 for Proceedings of the Japan Academy, Ser. B]

%% luatexja
\ifx\directlua\@undefined\else
\RequirePackage{luatexja}
\fi

\def\pjabline@warning{\ClassWarning{pjab}}
\def\pjab@warning{\ClassWarningNoLine{pjab}}

\newif\if@pjabdraft \@pjabdraftfalse
\DeclareOption{pjabdraft}{\@pjabdrafttrue}

\newif\if@Proof \@Prooffalse
\DeclareOption{Proof}{\@Prooftrue}

\newcommand\@ptsize{}
\newif\if@restonecol
%\newif\if@titlepage
%\@titlepagefalse
%\if@compatibility\else
\DeclareOption{a4paper}
   {\setlength\paperheight {297mm}%
    \setlength\paperwidth  {210mm}}
\DeclareOption{pa4paper}
   {\setlength\paperheight {280mm}%
    \setlength\paperwidth  {210mm}}
%\fi
%\if@compatibility
% \renewcommand\@ptsize{0}
%\else
\DeclareOption{10pt}{\renewcommand\@ptsize{0}}
%\fi
\DeclareOption{11pt}{\renewcommand\@ptsize{1}}
\DeclareOption{12pt}{\renewcommand\@ptsize{2}}
%\if@compatibility\else
\DeclareOption{oneside}{\@twosidefalse \@mparswitchfalse}
%\fi
\DeclareOption{twoside}{\@twosidetrue  \@mparswitchtrue}
\DeclareOption{draft}{\setlength\overfullrule{5pt}}
%\if@compatibility\else
\DeclareOption{final}{\setlength\overfullrule{0pt}}
%\fi
%\DeclareOption{titlepage}{\@titlepagetrue}
%\if@compatibility\else
%\DeclareOption{notitlepage}{\@titlepagefalse}
%\fi
%\if@compatibility\else
\DeclareOption{onecolumn}{\@twocolumnfalse}
%\fi
\DeclareOption{twocolumn}{\@twocolumntrue}
\DeclareOption{leqno}{\input{leqno.clo}}
\DeclareOption{fleqn}{\input{fleqn.clo}}
\DeclareOption{openbib}{%
  \AtEndOfPackage{%
   \renewcommand\@openbib@code{%
      \advance\leftmargin\bibindent
      \itemindent -\bibindent
      \listparindent \itemindent
      \parsep \z@
      }%
   \renewcommand\newblock{\par}}%
}
\ExecuteOptions{a4paper,10pt,twoside,onecolumn,final}
\ProcessOptions
\if@pjabdraft\else
 \setlength\paperheight{280mm}%
\fi

\if@pjabdraft
 \renewcommand\@ptsize{2}%
\else
 \@twocolumntrue
\fi

%%\input{size1\@ptsize.clo}
%% <size10.clo>
\if@pjabdraft
\renewcommand\normalsize{%
   \@setfontsize\normalsize\@xiipt{14.5pt}%
   \abovedisplayskip 12\p@ \@plus3\p@ \@minus7\p@
   \abovedisplayshortskip \z@ \@plus3\p@
   \belowdisplayshortskip 6.5\p@ \@plus3.5\p@ \@minus3\p@
   \belowdisplayskip \abovedisplayskip
   \let\@listi\@listI}
\normalsize
\ifx\MakeRobust\@undefined \else
    \MakeRobust\normalsize
\fi
\DeclareRobustCommand\small{%
   \@setfontsize\small\@xipt{13.6}%
   \abovedisplayskip 11\p@ \@plus3\p@ \@minus6\p@
   \abovedisplayshortskip \z@ \@plus3\p@
   \belowdisplayshortskip 6.5\p@ \@plus3.5\p@ \@minus3\p@
   \def\@listi{\leftmargin\leftmargini
               \topsep 9\p@ \@plus3\p@ \@minus5\p@
               \parsep 4.5\p@ \@plus2\p@ \@minus\p@
               \itemsep \parsep}%
   \belowdisplayskip \abovedisplayskip
}
\DeclareRobustCommand\footnotesize{%
   \@setfontsize\footnotesize\@xpt\@xiipt
   \abovedisplayskip 10\p@ \@plus2\p@ \@minus5\p@
   \abovedisplayshortskip \z@ \@plus3\p@
   \belowdisplayshortskip 6\p@ \@plus3\p@ \@minus3\p@
   \def\@listi{\leftmargin\leftmargini
               \topsep 6\p@ \@plus2\p@ \@minus2\p@
               \parsep 3\p@ \@plus2\p@ \@minus\p@
               \itemsep \parsep}%
   \belowdisplayskip \abovedisplayskip
}
\DeclareRobustCommand\scriptsize{\@setfontsize\scriptsize\@viiipt{9.5}}
\DeclareRobustCommand\tiny{\@setfontsize\tiny\@vipt\@viipt}
\DeclareRobustCommand\large{\@setfontsize\large\@xivpt{18}}
\DeclareRobustCommand\Large{\@setfontsize\Large\@xviipt{22}}
\DeclareRobustCommand\LARGE{\@setfontsize\LARGE\@xxpt{25}}
\DeclareRobustCommand\huge{\@setfontsize\huge\@xxvpt{30}}
\let\Huge=\huge
\else
\renewcommand\normalsize{%
 \@setfontsize\normalsize\@xpt\@xiipt
 \abovedisplayskip .5\baselineskip
  \@plus .25\baselineskip \@minus .15\baselineskip
 \abovedisplayshortskip\z@ \@plus .15\baselineskip
 \belowdisplayshortskip.3\baselineskip
  \@plus.15\baselineskip \@minus .1\baselineskip
 \belowdisplayskip \abovedisplayskip
 \let\@listi\@listI}
\normalsize
\ifx\MakeRobust\@undefined \else
    \MakeRobust\normalsize
\fi
\DeclareRobustCommand\small{%
 \@setfontsize\small\@ixpt{11}%
 \abovedisplayskip .5\baselineskip
  \@plus .25\baselineskip \@minus .15\baselineskip
 \abovedisplayshortskip\z@ \@plus .15\baselineskip
 \belowdisplayshortskip.3\baselineskip
  \@plus.15\baselineskip \@minus .1\baselineskip
 \belowdisplayskip \abovedisplayskip
 \def\@listi{\leftmargin\leftmargini
             \topsep 4\p@ \@plus2\p@ \@minus2\p@
             \parsep 2\p@ \@plus\p@ \@minus\p@
             \itemsep \parsep}%
}
\DeclareRobustCommand\footnotesize{%
 \@setfontsize\footnotesize\@viiipt{9.5}%
 \abovedisplayskip .5\baselineskip
  \@plus .25\baselineskip \@minus .15\baselineskip
 \abovedisplayshortskip\z@ \@plus .15\baselineskip
 \belowdisplayshortskip.3\baselineskip
  \@plus.15\baselineskip \@minus .1\baselineskip
 \belowdisplayskip \abovedisplayskip
 \def\@listi{\leftmargin\leftmargini
             \topsep 3\p@ \@plus\p@ \@minus\p@
             \parsep 2\p@ \@plus\p@ \@minus\p@
             \itemsep \parsep}%
}
\DeclareRobustCommand\scriptsize{\@setfontsize\scriptsize\@viipt\@viiipt}
\DeclareRobustCommand\tiny{\@setfontsize\tiny\@vpt\@vipt}
\DeclareRobustCommand\large{\@setfontsize\large\@xiipt{17}}% 14
\DeclareRobustCommand\Large{\@setfontsize\Large\@xivpt{18}}
\DeclareRobustCommand\LARGE{\@setfontsize\LARGE\@xviipt{22}}
\DeclareRobustCommand\huge{\@setfontsize\huge\@xxpt{25}}
\DeclareRobustCommand\Huge{\@setfontsize\Huge\@xxvpt{30}}
\fi

\if@twocolumn
  \setlength\parindent{2em}
\else
  \setlength\parindent{15\p@}
\fi
\setlength\smallskipamount{3\p@ \@plus 1\p@ \@minus 1\p@}
\setlength\medskipamount{6\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\bigskipamount{12\p@ \@plus 4\p@ \@minus 4\p@}

\if@pjabdraft
 \headheight10\p@
 \topskip12\p@
 \textheight 46\baselineskip %??
 \advance \textheight \topskip
 \topmargin 60\p@
 \advance \topmargin -1in
\else
 \headheight8\p@
 \topskip10\p@
 \textheight 51\baselineskip
 \advance \textheight \topskip
 \topmargin 75\p@
 \advance \topmargin -1in
\fi
\headsep20\p@ % 22pt
\footskip\z@
\maxdepth.5\topskip
\textwidth467\p@
%\@settopoint\textwidth
%\@settopoint\textheight
%\@settopoint\topmargin

\if@twocolumn
 \setlength\marginparsep{10\p@}
\else
 \setlength\marginparsep{10\p@}
\fi
\setlength\marginparpush{5\p@}

\oddsidemargin\paperwidth
\advance \oddsidemargin -\textwidth
\divide \oddsidemargin \tw@
\advance \oddsidemargin -1in
%\@settopoint\oddsidemargin
\evensidemargin\oddsidemargin
%\@settopoint\evensidemargin

\marginparwidth 2in
%\@settopoint\marginparwidth

\setlength\footnotesep{6.65\p@}% 9.5x.7
\setlength{\skip\footins}{9\p@ \@plus 4\p@ \@minus 2\p@}
\setlength\floatsep    {12\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\textfloatsep{20\p@ \@plus 2\p@ \@minus 4\p@}
\setlength\intextsep   {12\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\dblfloatsep    {12\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\dbltextfloatsep{20\p@ \@plus 2\p@ \@minus 4\p@}
\setlength\@fptop{0\p@ \@plus 1fil}
\setlength\@fpsep{8\p@ \@plus 2fil}
\setlength\@fpbot{0\p@ \@plus 1fil}
\setlength\@dblfptop{0\p@ \@plus 1fil}
\setlength\@dblfpsep{8\p@ \@plus 2fil}
\setlength\@dblfpbot{0\p@ \@plus 1fil}
\setlength\partopsep{2\p@ \@plus 1\p@ \@minus 1\p@}
\def\@listi{\leftmargin\leftmargini
            \parsep 4\p@ \@plus2\p@ \@minus\p@
            \topsep 8\p@ \@plus2\p@ \@minus4\p@
            \itemsep4\p@ \@plus2\p@ \@minus\p@}
\let\@listI\@listi
\@listi
\def\@listii {\leftmargin\leftmarginii
              \labelwidth\leftmarginii
              \advance\labelwidth-\labelsep
              \topsep    4\p@ \@plus2\p@ \@minus\p@
              \parsep    2\p@ \@plus\p@  \@minus\p@
              \itemsep   \parsep}
\def\@listiii{\leftmargin\leftmarginiii
              \labelwidth\leftmarginiii
              \advance\labelwidth-\labelsep
              \topsep    2\p@ \@plus\p@\@minus\p@
              \parsep    \z@
              \partopsep \p@ \@plus\z@ \@minus\p@
              \itemsep   \topsep}
\def\@listiv {\leftmargin\leftmarginiv
              \labelwidth\leftmarginiv
              \advance\labelwidth-\labelsep}
\def\@listv  {\leftmargin\leftmarginv
              \labelwidth\leftmarginv
              \advance\labelwidth-\labelsep}
\def\@listvi {\leftmargin\leftmarginvi
              \labelwidth\leftmarginvi
              \advance\labelwidth-\labelsep}
%% </size10.clo>

\setlength\lineskip{1\p@}
\setlength\normallineskip{1\p@}
\renewcommand\baselinestretch{}
\setlength\parskip{\z@}% 0\p@ \@plus \p@
\@lowpenalty   51
\@medpenalty  151
\@highpenalty 301
\setcounter{topnumber}{5}% 2
\setcounter{bottomnumber}{4}% 1
\setcounter{totalnumber}{9}% 3
\setcounter{dbltopnumber}{5}% 2
\renewcommand{\topfraction}{.95}% .7
\renewcommand{\bottomfraction}{.95}% .3
\renewcommand{\textfraction}{.05}% .2
\renewcommand{\floatpagefraction}{.05}% .5
\renewcommand{\dbltopfraction}{.95}% .7
\renewcommand{\dblfloatpagefraction}{.05}% .5

\if@Proof
 \def\@Rtop{\rlap{\smash{\rule[-\headsep]{0.05mm}{10mm}%
  \rule[-\headsep]{10mm}{0.05mm}}}}
 \def\@Ltop{\llap{\smash{\rule[-\headsep]{10mm}{0.05mm}%
  \rule[-\headsep]{0.05mm}{10mm}}}}
 \def\@Rbot{\rlap{\smash{\raisebox{1\footskip}
  {\rule[-10mm]{0.05mm}{10mm}\rule{10mm}{0.05mm}}}}}
 \def\@Lbot{\llap{\smash{\raisebox{1\footskip}
  {\rule{10mm}{0.05mm}\rule[-10mm]{0.05mm}{10mm}}}}}
\else
 \let\@Rtop\relax\let\@Ltop\relax\let\@Rbot\relax\let\@Lbot\relax
\fi

\def\Vol#1{% Vol.97 = Year 2021
 \def\@tempa{#1}%
 \ifx\@tempa\empty
  \gdef\@Vol{xx}\gdef\@Year{20xx}%
 \else
  \edef\@tempb{\zap@space#1 \@empty}%
  \afterassignment\remove@to@nnil
   \count@ 0\@tempb\relax\@nnil
  \ifnum\count@=\z@
   \gdef\@Vol{xx}%
  \else
   \@tempcnta=#1\relax
   \advance \@tempcnta 1924\relax
   \xdef\@Year{\the\@tempcnta}%
   \gdef\@Vol{\zap@space#1 \@empty}%
  \fi
 \fi
}
\def\@Vol{xx}%
\def\@Year{20xx}

\def\No#1{%
 \def\@tempa{#1}%
 \ifx\@tempa\empty
  \gdef\@No{xx}%
 \else
   \gdef\@No{#1}%
 \fi
}
\def\@No{xx}

\if@pjabdraft
\let\output@DOI\relax
\let\doi\@gobbletwo
\else
\def\doi#1#2{\gdef\doi@num{#1}\gdef\pjab@num{#2}}
\def\doi@num{}\def\pjab@num{}
\def\output@DOI{%
 \ifx\doi@num\@empty\else
  \smash{\hbox to \z@{\scriptsize
   \lower32\p@\hbox to \z@{doi: \doi@num/pjab.\pjab@num\hss}%
   \lower41\p@\hbox to \z@{\copyright\@Year\ The Japan Academy\hss}%
  \hss}}%
 \fi
}
\fi

\def\ps@pjabFPheadings{%
 \def\@evenfoot{\@Lbot\output@DOI\hfil\@Rbot}%
 \let\@oddfoot\@evenfoot
 \def\@evenhead{\@Ltop{\footnotesize\rlap{\thepage}\hfil
  Proc.\ Jpn.\ Acad., Ser.\ B \textbf{\@Vol} (\@Year)\hfil
  \if@pjabdraft\else\llap{[Vol.\ \@Vol}\fi}%]
 \@Rtop}%
 \def\@oddhead{\@Ltop{\footnotesize %[
  \if@pjabdraft\else\rlap{No.\ \@No]}\fi
  \hfil
  Proc.\ Jpn.\ Acad., Ser.\ B \textbf{\@Vol} (\@Year)\hfil \llap{\thepage}}%
 \@Rtop}%
 \let\@mkboth\markboth
}
\def\ps@pjabheadings{%
 \def\@evenfoot{\@Lbot\hfil\@Rbot}%
 \let\@oddfoot\@evenfoot
 \def\@evenhead{\@Ltop{\footnotesize\rlap{\thepage}\hfil
  \output@Hauthorlist\hfil 
  \if@pjabdraft\else\llap{[Vol.\ \@Vol}\fi}%]
 \@Rtop}%
 \def\@oddhead{\@Ltop{\footnotesize %[
  \if@pjabdraft\else\rlap{No.\ \@No]}\fi\hfil
  \head@title\hfil\llap{\thepage}}\@Rtop}%
 \let\@mkboth\markboth
}

\def\measure@head#1{%
 \setbox\@tempboxa\hbox{\def\\{\unskip\ignorespaces}%
  \footnotesize #1}%
 \ifdim \wd\@tempboxa > 420\p@
  \pjab@warning{header is too long. make it shorter. 
  ^^J\@spaces For example, \string\title[header title]{title}}%
    \fi
}

\def\title{\@ifnextchar[% ]
 {\d@title}{\s@title}}
\def\d@title[#1]#2{%
 \gdef\head@title{#1}\measure@head{#1}%
 \gdef\@title{#2}}
\def\s@title#1{%
 \gdef\head@title{\def\\{\unskip\ignorespaces}#1}%
 \measure@head{#1}\gdef\@title{#1}}
\def\@title{}
\def\head@title{}

\def\subtitle#1{\gdef\@subtitle{#1}}
\def\@subtitle{}

\newtoks\@authorlist
\newcount\@authorcnt
\newcount\@alcnt
\newcount\total@nr

\def\authorlist#1{%
 \@authorlist={#1}\the\@authorlist
}

\newif\if@correspondauthor \@correspondauthorfalse
\newif\if@nocorresponding \@nocorrespondingtrue
\def\authorentry{\@ifnextchar[% ]
 {\@correspondauthorfalse\pjab@ae}{\@correspondauthorfalse\pjab@ae[]}%
}
\def\Cauthorentry{%
 \@ifnextchar[% ]
 {\@correspondauthortrue\@nocorrespondingfalse\pjab@ae}%
 {\@correspondauthortrue\@nocorrespondingfalse\pjab@ae[]}%
}

\def\auth@comma{,}

\def\pjab@ae[#1]#2#3{%
 \def\tmp@an{#2}%
 \ifx\tmp@an\empty
 \else
  \@tempcnta\z@
  \advance \@authorcnt \@ne
  %% author label
  \get@al{#3}%
  %% author's names on header
  \def\tmp@initial{#1}%
  \@temptokena{#2}%
  \ifx\tmp@initial\empty
   \chk@name{#2}%
   \def\tmp@name##1 ##2\@nil{\get@oneword. \protect\textsc{##2}}%
  \else
   \def\tmp@name##1 ##2\@nil{\tmp@initial\ \protect\textsc{##2}}%
  \fi
  \protected@edef\fmt@headauthor{%
   \expandafter\tmp@name\the\@temptokena\@nil}%
  \expandafter\protected@xdef\csname @Hauthorname\number\@authorcnt\endcsname{%
   \fmt@headauthor}%
  %% author's name in English
  \@temptokena{#2}%
  \def\tmp@name##1 ##2\@nil{##1 \protect\textsc{##2}}%
  \protected@edef\fmt@authorname{%
    \expandafter\tmp@name\the\@temptokena\@nil}%
  \expandafter\protected@xdef\csname @Eauthorname\number\@authorcnt\endcsname{%
   \fmt@authorname\unskip\protect\auth@comma\kern\z@\plural@affi
   \if@correspondauthor$^{,\dagger}$\fi}%
  \global\total@nr\@authorcnt
  \def\plural@affi{}%
 \fi
}

\def\name@expandafter#1#2{%
 \def\next{#1}%
 \edef\@tempa{#2}%
 \ifx\@tempa\@empty
  \risee@warning{author's name is empty!}%
  \def\@tempa{\@empty}%
 \fi
 \expandafter\next\@tempa}
\def\chk@name#1{%
 \name@expandafter\@chk@name{#1}\@nil}
\def\@chk@name#1#2\@nil{\def\get@oneword{#1}}

\def\output@Hauthorlist{%
 \@authorcnt\z@
 \@tempcnta\total@nr \advance \@tempcnta -\@ne
 \ifnum\total@nr>3\relax
  \mbox{\csname @Hauthorname1\endcsname\unskip} \textit{et al.}%
 \else
  \loop
   \ifnum \@authorcnt < \total@nr
    \advance \@authorcnt \@ne 
    \ifnum \@authorcnt < \@tempcnta
     \ignorespaces
     \mbox{\csname @Hauthorname\number\@authorcnt\endcsname\unskip}, 
     %%\csname @breakauthorline\number\@authorcnt\endcsname
    \else
     \ifnum \@authorcnt=\total@nr
      \ignorespaces
      \mbox{\csname @Hauthorname\number\@authorcnt\endcsname\unskip}%
      %%\csname @breakauthorline\number\@authorcnt\endcsname
      \ignorespaces
     \else
      \ignorespaces
      \mbox{\csname @Hauthorname\number\@authorcnt\endcsname\unskip}\ 
      %%\csname @breakauthorline\number\@authorcnt\endcsname
      %% \ifnum \total@nr=\tw@\ \else , \fi
      and\ \ignorespaces 
     \fi
    \fi
  \repeat
 \fi
}

%\let\pjab@fnsymbol\@fnsymbol
\def\pjab@fnsymbol{\ast}

\def\get@al#1{%
 \def\al@none{none}\def\@tempaffi{#1}%
 \ifx\al@none\@tempaffi\else
  \@for\get@label:=#1\do{%
   \@ifundefined{al@\get@label}%
    {%
     \global\advance \@alcnt \@ne
     \expandafter\xdef\csname al@\get@label\endcsname{\the\@alcnt}%
     \global\advance \@tempcnta \@ne
     \protected@xdef\plural@affi{\plural@affi
      \ifnum\@tempcnta=\@ne
       $^{\pjab@fnsymbol{\csname al@\get@label\endcsname}}$%
      \else
       $^{,\pjab@fnsymbol{\csname al@\get@label\endcsname}}$%
      \fi
     }%
    }%
    {%
     \global\advance \@tempcnta \@ne
     \protected@xdef\plural@affi{\plural@affi
      \ifnum\@tempcnta=\@ne
       $^{\pjab@fnsymbol{\csname al@\get@label\endcsname}}$%
      \else
       $^{,\pjab@fnsymbol{\csname al@\get@label\endcsname}}$%
      \fi
     }%
    }%
  }%
 \fi
}
\def\plural@affi{}

\newcount\chk@alcnt
\def\affiliate[#1]#2{%
 \advance \chk@alcnt \@ne
 \@ifundefined{al@#1}%
  {\expandafter\def\csname al@#1\endcsname{1}%
   \pjab@warning{Check the "#1" label of \string\affiliate, 
     ^^J\@spaces it does not correspond to any labels of \string\authorentry\space command}%
  }{}%
 \protected@xdef\@affiliate{%
  \@affiliate
  \protect\footnotetext[\csname al@#1\endcsname]{#2}}%
}
\def\@affiliate{}

\def\breakauthorline#1{%
 \@for\@breakauthor:=#1\do{%
  \expandafter\gdef\csname @breakauthorline\@breakauthor\endcsname{\\}%
 }%
  \@authorcnt=\z@
  \loop\ifnum\@authorcnt<\total@nr
   \advance \@authorcnt \@ne
    \@ifundefined{@breakauthorline\number\@authorcnt}%
     {\expandafter\gdef\csname @breakauthorline\number\@authorcnt\endcsname{%
      \relax}}
     {\relax}%
  \repeat
}

\def\output@Eauthorlist{%
 \@authorcnt\z@
 \@tempcnta\total@nr \advance \@tempcnta -\@ne
  \loop
   \ifnum \@authorcnt < \total@nr
    \advance \@authorcnt \@ne 
    \ifnum \@authorcnt < \@tempcnta
     \ignorespaces
     \mbox{\csname @Eauthorname\number\@authorcnt\endcsname\unskip}\ %,
     \csname @breakauthorline\number\@authorcnt\endcsname
    \else
     \ifnum \@authorcnt=\total@nr
      \ignorespaces
      \let\auth@comma\relax
      \mbox{\csname @Eauthorname\number\@authorcnt\endcsname\unskip}%
      \csname @breakauthorline\number\@authorcnt\endcsname
      \ignorespaces
     \else
      \ignorespaces
      \let\auth@comma\relax
      \mbox{\csname @Eauthorname\number\@authorcnt\endcsname\unskip}\ 
      \csname @breakauthorline\number\@authorcnt\endcsname
      %% \ifnum \total@nr=\tw@\ \else , \fi
      and\ \ignorespaces 
     \fi
    \fi
  \repeat
}

\def\Correspondence#1{%
 \if@nocorresponding
  \pjab@warning{No corresponding author. 
   Maybe, should be changed \string\authorentry\space to \string\Cauthorentry}%
 \fi
 \gdef\@Correspondence{%
  \let\ast\dagger
  \let\thefootnote\relax
  \footnotetext[0]{Correspondence should be addressed to: \ignorespaces#1}}}
\def\@Correspondence{}

\def\Abbreviations#1{%
 \gdef\@Abbreviations{%
  \let\ast\relax
  \let\thefootnote\relax
  \footnotetext[0]{Abbreviations: \ignorespaces#1}}}
\def\@Abbreviations{}

\def\ed-mja#1{\gdef\@edmja{#1}}
\def\@edmja{}

\long\def\abstract#1{\gdef\@abstract{\ignorespaces #1}}
\long\def\keywords#1{\gdef\@keywords{\ignorespaces #1}}
\def\@abstract{}
\def\@keywords{}

%\newbox\@abstractbox
%\def\abstract{%
%  \global\setbox\@abstractbox\hbox\bgroup
%   \begin{minipage}{423\p@}
%    %\normalsize\baselineskip12.5\p@
%    \normalsize\if@pjabdraft\else\baselineskip12.5\p@\fi
%    \parindent2em
%    {\bfseries Abstract: }%
%    \ignorespaces
%}
%\def\endabstract{%
%   \end{minipage}%
%  \egroup
%}

%\newbox\@keywordbox
%\def\keywords{%
%  \global\setbox\@keywordbox\hbox\bgroup
%   \begin{minipage}{423\p@}
%    %\normalsize\baselineskip12.5\p@
%    \normalsize\if@pjabdraft\else\baselineskip12.5\p@\fi
%    \parindent2em
%    {\bfseries Keywords: }%
%    \ignorespaces
%}
%\def\endkeywords{%
%   \end{minipage}%
%  \egroup
%}

\def\pjabcategory#1{\gdef\pjab@category{#1}}
\def\pjab@category{}

\newcommand{\maketitle}{\par
 %%\headauthors{\output@Hauthorlist}%
 %\typeout{!! alcnt=\the\@alcnt}%
 %\typeout{!! chkalcnt=\the\chk@alcnt}%
 \ifnum\@alcnt=\chk@alcnt\else
  \pjab@warning{Numbers of \string\affiliate\space and \string\authorentry\space label do not match. Check them}%
 \fi
 \begingroup
  \def\@makefnmark{\hbox{$\m@th^{\@thefnmark}$}}% in title etc.
  \long\def\@makefntext##1{%
   %\hangindent29\p@
   \noindent
   \hbox to 29\p@{\hss\hss\hss$\m@th^{\ast\@thefnmark}$\hss\hss}##1}%
  %%
  \if@pjabdraft
   \global\@topnum\z@   % Prevents figures from going at top of page.
   \@maketitle
  \else
   \twocolumn[\@maketitle]%
  \fi
  \thispagestyle{pjabFPheadings}%
  \@affiliate
  \@Correspondence
  \@Abbreviations
 \endgroup
 \setcounter{footnote}{0}%
 \global\let\maketitle\relax
 \global\let\@maketitle\relax
 \global\let\@title\@empty
 \global\let\title\relax
 \global\let\@authorlist\relax
 \global\let\@affiliate\@empty
 \global\let\affiliate\relax
 \global\let\output@Eauthorlist\@empty
 \@authorcnt\z@
 \loop\ifnum \@authorcnt < \total@nr
  \advance \@authorcnt \@ne
   \global\expandafter\let\csname @Eauthorname\number\@authorcnt\endcsname
    \@empty
 \repeat
}

\def\title@font{\large\bfseries}
\def\subtitle@font{\normalsize\bfseries}
\def\author@font{\normalsize}

\def\@maketitle{%
 \if@pjabdraft
  \nolinenumbers
  \bgroup
   \parindent\z@
   \ifx\pjab@category\@empty
    \vskip14\p@
   \else
    \def\pjab@tmp@category{Review}%
    \ifx\pjab@category\pjab@tmp@category
     \vskip6\p@
     {\large\bfseries\hskip29\p@ \pjab@category}\par
     \vskip6\p@
    \else
     \vskip14\p@
    \fi
   \fi
   \bgroup
    \centering
    {\title@font\@title\par}%
   \egroup
   \ifx\@subtitle\@empty
    \vskip13\p@
   \else
    \vskip7\p@
    \centering
    {\subtitle@font \@subtitle\par}%
    \vskip13\p@
   \fi
   \bgroup
    \centering
    {\author@font By \output@Eauthorlist\par}%
   \egroup
   %\if@pjabdraft\else
   % \vskip15\p@
   % \ifx\@edmja\@empty{\scriptsize\mbox{\vphantom{Xy}}}\else
   %  {\scriptsize (\@edmja\unskip)}%
   % \fi
   %\fi
   %% 467 - 423 = 44
   \vskip18\p@
   \linenumbers
   \bgroup
    \parindent2em
    \leftskip22\p@
    \rightskip\leftskip
    {\bfseries Abstract: }\@abstract\par 
    \vskip15\p@
    \nolinenumbers
    {\bfseries Keywords: }\@keywords\par
   \egroup
  \egroup
 \else
  \setbox\@tempboxa\vbox{\hsize\textwidth
   \parindent\z@
   \ifx\pjab@category\@empty
    \vskip14\p@
   \else
    \def\pjab@tmp@category{Review}%
    \ifx\pjab@category\pjab@tmp@category
     \vskip6\p@
     {\large\bfseries\hskip29\p@ \pjab@category}\par
     \vskip6\p@
    \else
     \vskip14\p@
    \fi
   \fi
   \bgroup
    \centering
    {\title@font\@title\par}%
   \egroup
   \ifx\@subtitle\@empty
    \vskip13\p@
   \else
    \vskip7\p@
    \centering
    {\subtitle@font \@subtitle\par}%
    \vskip13\p@
   \fi
   \bgroup
    \centering
    {\author@font By \output@Eauthorlist\par}%
    \vskip15\p@
    \ifx\@edmja\@empty
     {\scriptsize\mbox{\vphantom{Xy}}\par}%
    \else
     {\scriptsize (\@edmja\unskip)\par}%
    \fi
   \egroup
   \vskip18\p@
   \parindent2em
   \leftskip22\p@
   \rightskip\leftskip
   {\bfseries Abstract: }\@abstract\par 
   \vskip15\p@
   {\bfseries Keywords: }\@keywords\par
  }%
  %%
  \@tempdima \ht\@tempboxa
  \advance \@tempdima \dp\@tempboxa
  \@tempdimb \@tempdima
  \@tempdimc \@tempdima
  \divide \@tempdimc \baselineskip
  \@tempcnta=\@tempdimc
  \advance \@tempcnta \@ne
  %%
  \@tempdimc \@tempcnta\baselineskip
  \advance \@tempdimb -\@tempdimc
  \ifdim \@tempdimb > .5\baselineskip
   \advance \@tempcnta \@ne
  \else
   \advance \@tempcnta \z@
  \fi
  \advance \@tempcnta \tw@
  %%
  \newpage\null
  \bgroup
   \parindent\z@
   \boxmaxdepth\z@
   \lineskiplimit\z@
   \lineskip\z@
   \vbox to \@tempcnta\baselineskip{%
    \box\@tempboxa
   \vss}%
  \egroup
 \fi
}

\setcounter{secnumdepth}{3}
\newcounter {section}
\newcounter {subsection}[section]
\newcounter {subsubsection}[subsection]
\newcounter {paragraph}[subsubsection]
\newcounter {subparagraph}[paragraph]
\renewcommand\thesection {\@arabic\c@section}
\renewcommand\thesubsection   {\thesection.\@arabic\c@subsection}
\renewcommand\thesubsubsection{\thesubsection.\@arabic\c@subsubsection}
\renewcommand\theparagraph    {\thesubsubsection.\@arabic\c@paragraph}
\renewcommand\thesubparagraph {\theparagraph.\@arabic\c@subparagraph}

\def\@startsection#1#2#3#4#5#6{%
 \if@noskipsec \leavevmode \fi
 \par
 \@tempskipa #4\relax
 \@afterindenttrue
 \ifdim \@tempskipa <\z@ \@tempskipa -\@tempskipa \@afterindentfalse\fi
  \if@nobreak
   \everypar{}%
  \else
   \ifx\doublespacing\@undefined
    \ifdim\@tempskipa>\z@
     \ifnum#2=\@ne
      \vskip-\prevdepth \prevdepth\z@ \vskip\baselineskip
      \advance\@tempskipa-\baselineskip
      \vspace*{\@tempskipa}
     \else
      \addvspace\@tempskipa
     \fi
    \fi
   \else
    \ifnum#2=\@ne
     \addpenalty\@secpenalty\addvspace\@tempskipa
     \vspace{.4\baselineskip}% for bug of setspace.sty
    \fi
   \fi
  \fi
 \@ifstar{\@ssect{#3}{#4}{#5}{#6}}{\@dblarg{\@sect{#1}{#2}{#3}{#4}{#5}{#6}}}}

%% \@sect{NAME}{LEVEL}{INDENT}{BEFORESKIP}{AFTERSKIP}{STYLE}[ARG1]{ARG2}
%% \ifdim \@tempskipa>\z@ --> \ifdim \@tempskipa<\z@
\def\@sect#1#2#3#4#5#6[#7]#8{%
 \ifnum #2>\c@secnumdepth
  \let\@svsec\@empty
 \else
  \refstepcounter{#1}%
  \protected@edef\@svsec{\@seccntformat{#1}\relax}%
 \fi
  \@tempskipa #5\relax
  \ifdim \@tempskipa<\z@
   \def\@svsechd{%
     #6{\hskip #3\relax
     \@svsec\ignorespaces#8\unskip.}%
    %\csname #1mark\endcsname{#7}%
    %\addcontentsline{toc}{#1}{%
    % \ifnum #2>\c@secnumdepth \else
    %   \protect\numberline{\csname the#1\endcsname}%
    % \fi
    % #7}%
   }%
  \else
   \begingroup
    #6{%
     \ifnum#2=\@ne
      \centering
      \@svsec
      \interlinepenalty\@M\ignorespaces#8\@@par
     \else
      \@hangfrom{\hskip #3\relax\@svsec}%
       \interlinepenalty\@M\ignorespaces#8\@@par
     \fi
      }%
   \endgroup
   %\csname #1mark\endcsname{#7}%
   %\addcontentsline{toc}{#1}{%
   % \ifnum #2>\c@secnumdepth \else
   %  \protect\numberline{\csname the#1\endcsname}%
   % \fi
   % #7}%
  \fi
  \@xsect{#5}}

%% \@ssect{INDENT}{BEFORESKIP}{AFTERSKIP}{STYLE}{ARG} ==
%% \ifdim \@tempskipa>\z@ --> \ifdim \@tempskipa<\z@
\def\@ssect#1#2#3#4#5{%
 \@tempskipa #3\relax
 \ifdim \@tempskipa<\z@
  \def\@svsechd{#4{\hskip #1\relax #5\unskip.}}%
 \else % for section*
  \begingroup
    #4{%
      %\@hangfrom{\hskip #1}%
      \centering
      \interlinepenalty\@M\ignorespaces#5\@@par}%
  \endgroup
 \fi
 \@xsect{#3}}

%% \ifdim \@tempskipa>\z@ --> \ifdim \@tempskipa<\z@
\def\@xsect#1{%
  \@tempskipa #1\relax
  \ifdim \@tempskipa<\z@
    \@nobreakfalse
    \global\@noskipsectrue
    \everypar{%
      \if@noskipsec
        \global\@noskipsecfalse
       {\setbox\z@\lastbox}%
        \clubpenalty\@M
        \begingroup \@svsechd \endgroup
        \unskip
        \@tempskipa #1\relax
        \hskip -\@tempskipa
        %\pagebreak[1]% 2-->1
      \else
        \clubpenalty \@clubpenalty
        \everypar{}%
      \fi}%
  \else
    \par \nobreak
    \vskip \@tempskipa
    \@afterheading
  \fi
  \ignorespaces}

\def\@seccntformat#1{\csname the#1\endcsname.\ }%

\newcommand\section{\@startsection{section}{1}{\z@}% }{
 {.5\baselineskip}% \@plus.25\baselineskip \@minus.1\baselineskip
 {.5\baselineskip}%
 {\normalfont\small
  \if@pjabdraft\baselineskip14.5\p@\else\baselineskip12\p@\fi
  \bfseries}}
\newcommand\subsection{\@startsection{subsection}{2}{20\p@}% }{
 {\z@}%
 {-1em}%
 {\normalfont\small
  \if@pjabdraft\baselineskip14.5\p@\else\baselineskip12\p@\fi
  \bfseries}}
\newcommand\subsubsection{\@startsection{subsubsection}{3}{20\p@}% }{
 {\z@}%
 {-1em}%
 {\normalfont\normalsize\itshape}}
\newcommand\paragraph{\@startsection{paragraph}{4}{\parindent}% }{
 {\z@}% 3.25ex \@plus1ex \@minus.2ex
 {-1em}%
 {\normalfont\normalsize\bfseries}}
\newcommand\subparagraph{\@startsection{subparagraph}{5}{\parindent}% }{
 {\z@}% 3.25ex \@plus1ex \@minus.2ex
 {-1em}%
 {\normalfont\normalsize\bfseries}}

\if@twocolumn
  \setlength\leftmargini  {2em}
\else
  \setlength\leftmargini  {2.5em}
\fi
\leftmargin  \leftmargini
\setlength\leftmarginii  {2.2em}
\setlength\leftmarginiii {1.87em}
\setlength\leftmarginiv  {1.7em}
\if@twocolumn
  \setlength\leftmarginv  {.5em}
  \setlength\leftmarginvi {.5em}
\else
  \setlength\leftmarginv  {1em}
  \setlength\leftmarginvi {1em}
\fi
\setlength  \labelsep  {.5em}
\setlength  \labelwidth{\leftmargini}
\addtolength\labelwidth{-\labelsep}
\@beginparpenalty -\@lowpenalty
\@endparpenalty   -\@lowpenalty
\@itempenalty     -\@lowpenalty

\renewcommand\theenumi{\@arabic\c@enumi}
\renewcommand\theenumii{\@alph\c@enumii}
\renewcommand\theenumiii{\@roman\c@enumiii}
\renewcommand\theenumiv{\@Alph\c@enumiv}
\newcommand\labelenumi{\theenumi.}
\newcommand\labelenumii{(\theenumii)}
\newcommand\labelenumiii{\theenumiii.}
\newcommand\labelenumiv{\theenumiv.}
\renewcommand\p@enumii{\theenumi}
\renewcommand\p@enumiii{\theenumi(\theenumii)}
\renewcommand\p@enumiv{\p@enumiii\theenumiii}

\renewenvironment{enumerate}
  {\ifnum \@enumdepth >\thr@@\@toodeep\else
   \advance\@enumdepth\@ne
   \edef\@enumctr{enum\romannumeral\the\@enumdepth}%
   \list{\csname label\@enumctr\endcsname}{%
         %\ifnum \@listdepth=\@ne \topsep.5\normalbaselineskip
         %  \else\topsep\z@\fi
         \topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
         \settowidth{\labelwidth}{\csname label\@enumctr\endcsname}%
         \labelsep.75em
         %\ifnum \@enumdepth=\@ne \leftmargin1em\relax
         %  \else\leftmargin\leftskip\fi
         \advance\leftmargin .25em
         \clubpenalty\z@
         \widowpenalty\z@
         \@itempenalty\z@
         \usecounter{\@enumctr}%
         \def\makelabel##1{\hss\llap{##1}}}%
   \fi}{\endlist}

\newcommand\labelitemi  {\labelitemfont \hbox to 2.5em{\hss\textbullet\hss}}
\newcommand\labelitemii {\labelitemfont \bfseries \hbox to 2.5em{\hss\textendash\hss}}
\newcommand\labelitemiii{\labelitemfont \hbox to 2.5em{\hss\textasteriskcentered\hss}}
\newcommand\labelitemiv{ \labelitemfont \hbox to 2.5em{\hss\textperiodcentered\hss}}
\newcommand\labelitemfont{\normalfont}

\renewenvironment{itemize}
  {\ifnum \@itemdepth >3\relax\@toodeep\else
   \advance\@itemdepth\@ne
   \edef\@itemitem{labelitem\romannumeral\the\@itemdepth}%
   \expandafter
   \list{\csname \@itemitem\endcsname}{% 
   %\expandafter \list \csname \@itemitem\endcsname{% 2018
         \topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
         \labelwidth2.5em
         \labelsep\z@
         \leftmargin2.5em
         \listparindent\z@
         \clubpenalty\z@
         \widowpenalty\z@
         \@itempenalty\z@
         \def\makelabel##1{\hss\llap{##1}}}%
   \fi}{\endlist}

\newenvironment{description}
               {\list{}{\labelwidth\z@ \itemindent-\leftmargin
                        \let\makelabel\descriptionlabel}}
               {\endlist}
\newcommand*\descriptionlabel[1]{\hspace\labelsep
                                \normalfont\bfseries #1}
\newenvironment{verse}
               {\let\\\@centercr
                \list{}{\itemsep      \z@
                        \itemindent   -1.5em%
                        \listparindent\itemindent
                        \rightmargin  \leftmargin
                        \advance\leftmargin 1.5em}%
                \item\relax}
               {\endlist}
\newenvironment{quotation}
               {\list{}{\listparindent 1.5em%
                        \itemindent    \listparindent
                        \rightmargin   \leftmargin
                        \parsep        \z@ \@plus\p@}%
                \item\relax}
               {\endlist}
\newenvironment{quote}
               {\list{}{\rightmargin\leftmargin}%
                \item\relax}
               {\endlist}

\newcommand\appendix{\par
  \setcounter{section}{0}%
  \setcounter{subsection}{0}%
  \gdef\thesection{\@Alph\c@section}}

\setlength\arraycolsep{5\p@}
\setlength\tabcolsep{6\p@}
\setlength\arrayrulewidth{.4\p@}
\setlength\doublerulesep{\z@}% 2\p@
\setlength\tabbingsep{\labelsep}
\skip\@mpfootins = \skip\footins
\setlength\fboxsep{3\p@}
\setlength\fboxrule{.4\p@}

\renewcommand\theequation{\@arabic\c@equation}
%\def\@eqnnum{{\normalfont \normalcolor [\theequation]}}

\def\eqnarray{%
   \stepcounter{equation}%
   \def\@currentlabel{\p@equation\theequation}%
   \global\@eqnswtrue
   \m@th
   \global\@eqcnt\z@
   \tabskip\@centering
   \let\\\@eqncr
   $$\everycr{}\halign to\displaywidth\bgroup
       \hskip\@centering$\displaystyle\tabskip\z@skip{##}$\@eqnsel
      &\global\@eqcnt\@ne \hfil$\displaystyle{{}##{}}$\hfil
      &\global\@eqcnt\tw@ $\displaystyle{##}$\hfil\tabskip\@centering
      &\global\@eqcnt\thr@@ \hb@xt@\z@\bgroup\hss##\egroup
         \tabskip\z@skip
      \cr}

\newcounter{figure}
\renewcommand\thefigure{\@arabic\c@figure}
\def\fps@figure{tbp}
\def\ftype@figure{1}
\def\ext@figure{lof}
\def\fnum@figure{\figurename\nobreakspace\thefigure}
\newenvironment{figure}
               {\floatenv %\capwidth\hsize
                \abovecaptionskip5\p@\belowcaptionskip\z@\@float{figure}}
               {\end@float}
\newenvironment{figure*}
               {\floatenv %\capwidth\textwidth
                \abovecaptionskip5\p@\belowcaptionskip\z@\@dblfloat{figure}}
               {\end@dblfloat}
\newcounter{table}
\renewcommand\thetable{\@arabic\c@table}
\def\fps@table{tbp}
\def\ftype@table{2}
\def\ext@table{lot}
\def\fnum@table{\tablename\nobreakspace\thetable}
\newenvironment{table}
               {\floatenv %\capwidth\hsize
                \abovecaptionskip\z@\belowcaptionskip5\p@\@float{table}}
               {\end@float}
\newenvironment{table*}
               {\floatenv %\capwidth\textwidth
                \abovecaptionskip\z@\belowcaptionskip5\p@\@dblfloat{table}}
               {\end@dblfloat}

\newlength\abovecaptionskip
\newlength\belowcaptionskip
%\setlength\abovecaptionskip{10\p@}
%\setlength\belowcaptionskip{0\p@}

\def\@floatboxreset{%
 \reset@font
 \footnotesize\baselineskip10pt %\tabcolsep6pt
 \@setminipage
}

\def\floatenv{%
 \def\center{\centering}%
 \def\endcenter{\par\ignorespaces}%
}

%%\newdimen\capwidth

\long\def\@makecaption#1#2{%
  %\typeout{!!! \@captype=\the\hsize}% 467.0pt / 226.5pt
  \footnotesize\baselineskip10\p@
  \vskip\abovecaptionskip
  \sbox\@tempboxa{#1.\hskip1em\ignorespaces#2}%
  \ifdim \wd\@tempboxa >\hsize
    \ifdim\hsize>230\p@
     \hangindent15\p@
    \else
     \hangindent7\p@
    \fi
    #1.\hskip1em\ignorespaces#2\par
  \else
    \global \@minipagefalse
    \hb@xt@\hsize{\hfil\box\@tempboxa\hfil}%
  \fi
  \vskip\belowcaptionskip}

\DeclareOldFontCommand{\rm}{\normalfont\rmfamily}{\mathrm}
\DeclareOldFontCommand{\sf}{\normalfont\sffamily}{\mathsf}
\DeclareOldFontCommand{\tt}{\normalfont\ttfamily}{\mathtt}
\DeclareOldFontCommand{\bf}{\normalfont\bfseries}{\mathbf}
\DeclareOldFontCommand{\it}{\normalfont\itshape}{\mathit}
\DeclareOldFontCommand{\sl}{\normalfont\slshape}{\@nomath\sl}
\DeclareOldFontCommand{\sc}{\normalfont\scshape}{\@nomath\sc}
\DeclareRobustCommand*\cal{\@fontswitch\relax\mathcal}
\DeclareRobustCommand*\mit{\@fontswitch\relax\mathnormal}

%\newcommand\@pnumwidth{1.55em}
%\newcommand\@tocrmarg{2.55em}
%\newcommand\@dotsep{4.5}
%\setcounter{tocdepth}{3}
%\newcommand\tableofcontents{%
%    \section*{\contentsname
%        \@mkboth{%
%           \MakeUppercase\contentsname}{\MakeUppercase\contentsname}}%
%    \@starttoc{toc}%
%    }
%\newcommand*\l@part[2]{%
%  \ifnum \c@tocdepth >-2\relax
%    \addpenalty\@secpenalty
%    \addvspace{2.25em \@plus\p@}%
%    \setlength\@tempdima{3em}%
%    \begingroup
%      \parindent \z@ \rightskip \@pnumwidth
%      \parfillskip -\@pnumwidth
%      {\leavevmode
%       \large \bfseries #1\hfil
%       \hb@xt@\@pnumwidth{\hss #2%
%                          \kern-\p@\kern\p@}}\par
%       \nobreak
%       \if@compatibility
%         \global\@nobreaktrue
%         \everypar{\global\@nobreakfalse\everypar{}}%
%      \fi
%    \endgroup
%  \fi}
%\newcommand*\l@section[2]{%
%  \ifnum \c@tocdepth >\z@
%    \addpenalty\@secpenalty
%    \addvspace{1.0em \@plus\p@}%
%    \setlength\@tempdima{1.5em}%
%    \begingroup
%      \parindent \z@ \rightskip \@pnumwidth
%      \parfillskip -\@pnumwidth
%      \leavevmode \bfseries
%      \advance\leftskip\@tempdima
%      \hskip -\leftskip
%      #1\nobreak\hfil
%      \nobreak\hb@xt@\@pnumwidth{\hss #2%
%                                 \kern-\p@\kern\p@}\par
%    \endgroup
%  \fi}
%\newcommand*\l@subsection{\@dottedtocline{2}{1.5em}{2.3em}}
%\newcommand*\l@subsubsection{\@dottedtocline{3}{3.8em}{3.2em}}
%\newcommand*\l@paragraph{\@dottedtocline{4}{7.0em}{4.1em}}
%\newcommand*\l@subparagraph{\@dottedtocline{5}{10em}{5em}}
%\newcommand\listoffigures{%
%    \section*{\listfigurename}%
%      \@mkboth{\MakeUppercase\listfigurename}%
%              {\MakeUppercase\listfigurename}%
%    \@starttoc{lof}%
%    }
%\newcommand*\l@figure{\@dottedtocline{1}{1.5em}{2.3em}}
%\newcommand\listoftables{%
%    \section*{\listtablename}%
%      \@mkboth{%
%          \MakeUppercase\listtablename}%
%         {\MakeUppercase\listtablename}%
%    \@starttoc{lot}%
%    }
%\let\l@table\l@figure

\newdimen\bibindent
\setlength\bibindent{1.5em}
\newenvironment{thebibliography}[1]
     {\if@pjabdraft\nolinenumbers\fi
      \section*{\normalsize\refname}%
      \small
      \if@pjabdraft\else
       \baselineskip10pt
      \fi
      %\@mkboth{\MakeUppercase\refname}{\MakeUppercase\refname}%
      \list{\@biblabel{\@arabic\c@enumiv}}%
           {\settowidth\labelwidth{\@biblabel{#1}}%
            \topsep\z@\parsep\z@\partopsep\z@\itemsep\z@
            \labelsep10\p@
            \leftmargin\labelwidth
            \advance\leftmargin\labelsep
            \advance\leftmargin 8\p@
            \itemindent-8\p@
            \@openbib@code
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv}}%
      \sloppy
      \clubpenalty4000
      \@clubpenalty \clubpenalty
      \widowpenalty4000%
      \sfcode`\.\@m}
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist
      \if@pjabdraft\else
       \@acceptance
      \fi
     }
\newcommand\newblock{\hskip .11em\@plus.33em\@minus.07em}
\let\@openbib@code\@empty
\def\@biblabel#1{%(
 #1)}

\def\@acceptance{\@@par
 \footnotesize\baselineskip10\p@
 \ifx\@received\empty\else
  \vskip2\baselineskip
  \noindent\hfill
  (\@received\@accepted)\par
 \fi}

\def\num@abbmonth{% June,July ??
 \ifcase\@temp@m xxx\or Jan.\or Feb.\or Mar.\or Apr.\or
  May\or June\or July\or Aug.\or Sep.\or Oct.\or
  Nov.\or Dec.\fi}%

\def\received#1#2#3{\def\@temp@m{#2}%
 \xdef\@received{Received\ \num@abbmonth\ #3, #1}}

\def\accepted#1#2#3{\def\@temp@m{#2}%
 \xdef\@accepted{; accepted\ \num@abbmonth\ #3, #1}}
\def\@received{}
\def\@accepted{}

\newif\if@pjabprofile \@pjabprofilefalse

\long\def\profile[#1]#2{% width=439pt  pic 84x113pt (29.8x40mm)
 \if@pjabprofile
  \vskip3\baselineskip
 \else
  \@pjabprofiletrue
  \onecolumn
  \if@pjabdraft\nolinenumbers\singlespacing\fi
 \fi
 \leftskip14\p@ % (467-439)/2=14
 \rightskip\leftskip
 \noindent
 {\bfseries\fontsize{12}{12}\selectfont Profile}\par
 \vskip13pt
 \fontsize{9}{12}\selectfont
 \noindent
 \hangindent-99\p@
 \hangafter-10\relax
 \smash{\hbox to \z@{\hbox to 439\p@{\hss
  \pjab@profile@pic{#1}%
 }\hss}}\hskip2em
 #2%
}

\def\pjab@profile@pic#1{%
 \def\tmp@profile{#1}%
 \ifx\tmp@profile\@empty
  \lower37.65mm\hbox{%
   \vbox to 40mm{%
    \hrule height .1mm
     \hbox to 29.8mm{%
      \vrule width .1mm height 38.8mm
       \hss
      \vrule width .1mm height 38.8mm}%
    \hrule height .1mm}}%
 \else
  \IfFileExists{#1}%
   {\lower37.65mm\hbox{%
     \resizebox{29.8mm}{40mm}{\includegraphics{#1}}}%
   }%
   {\lower37.65mm\hbox{%
     \vbox to 40mm{%
      \hrule height .1mm
       \hbox to 29.8mm{%
        \vrule width .1mm height 38.8mm
         \hss
        \vrule width .1mm height 38.8mm}%
      \hrule height .1mm}}%
   }%
 \fi
}

%\newenvironment{theindex}
%               {\if@twocolumn
%                  \@restonecolfalse
%                \else
%                  \@restonecoltrue
%                \fi
%                \twocolumn[\section*{\indexname}]%
%                \@mkboth{\MakeUppercase\indexname}%
%                        {\MakeUppercase\indexname}%
%                \thispagestyle{plain}\parindent\z@
%                \parskip\z@ \@plus .3\p@\relax
%                \columnseprule \z@
%                \columnsep 35\p@
%                \let\item\@idxitem}
%               {\if@restonecol\onecolumn\else\clearpage\fi}
%\newcommand\@idxitem{\par\hangindent 40\p@}
%\newcommand\subitem{\@idxitem \hspace*{20\p@}}
%\newcommand\subsubitem{\@idxitem \hspace*{30\p@}}
%\newcommand\indexspace{\par \vskip 10\p@ \@plus5\p@ \@minus3\p@\relax}

\renewcommand\footnoterule{%
  \kern-3\p@
  \hrule\@width.4\columnwidth
  \kern2.6\p@}

\newcommand\@makefntext[1]{%
 \noindent
 \hbox to 29\p@{\hss\hss\hss$\m@th^{\@thefnmark}$\hss\hss}#1}%

%\newcommand\contentsname{Contents}
%\newcommand\listfigurename{List of Figures}
%\newcommand\listtablename{List of Tables}
\newcommand\refname{References}
%\newcommand\indexname{Index}
\newcommand\figurename{Fig.}
\newcommand\tablename{Table}
\newcommand\partname{Part}
\newcommand\appendixname{Appendix}
\newcommand\abstractname{Abstract}

\def\today{\ifcase\month\or
  January\or February\or March\or April\or May\or June\or
  July\or August\or September\or October\or November\or December\fi
  \space\number\day, \number\year}
\setlength\columnsep{14\p@}
\setlength\columnseprule{0\p@}

\if@pjabdraft
 \vbadness10001\relax % 1000
 \vfuzz1\p@ % 0.1pt
\else
% \hbadness2000 % 1000
\fi

\if@pjabdraft
 \RequirePackage[doublespacing]{setspace}%
 \RequirePackage[mathlines,pagewise]{lineno}%
\else
 \let\@LN\@gobbletwo
\fi

\AtBeginDocument{%
 \if@pjabdraft
  %%%\RequirePackage[pagewise]{lineno}% <- when pagewise, \@LN cause error.
  %% from https://tex.stackexchange.com/questions/461186/how-to-use-lineno-with-amsmath-align
  %% Patch 'normal' math environments:
  \RequirePackage{etoolbox}%
  \newcommand*\linenomathpatch[1]{%
    \cspreto{#1}{\linenomath}%
    \cspreto{#1*}{\linenomath}%
    \csappto{end#1}{\endlinenomath}%
    \csappto{end#1*}{\endlinenomath}%
  }%
  %% Patch AMS math environments:
  \newcommand*\linenomathpatchAMS[1]{%
    \cspreto{#1}{\linenomathAMS}%
    \cspreto{#1*}{\linenomathAMS}%
    \csappto{end#1}{\endlinenomath}%
    \csappto{end#1*}{\endlinenomath}%
  }%
  %% Definition of \linenomathAMS depends on whether the mathlines option is provided
  \expandafter\ifx\linenomath\linenomathWithnumbers
    \let\linenomathAMS\linenomathWithnumbers
    %% The following line gets rid of an extra line numbers at the bottom:
    \patchcmd\linenomathAMS{\advance\postdisplaypenalty\linenopenalty}{}{}{}%
  \else
    \let\linenomathAMS\linenomathNonumbers
  \fi
  \linenomathpatch{equation}%
  \linenomathpatchAMS{gather}%
  \linenomathpatchAMS{multline}%
  \linenomathpatchAMS{align}%
  \linenomathpatchAMS{alignat}%
  \linenomathpatchAMS{flalign}%
  %%
  \linenumbers
 \else
  %% pdf and ps papersize
  \AtBeginDvi{\special{papersize=210mm,280mm}}%
 \fi
 \displaywidowpenalty\z@
 \interdisplaylinepenalty\z@
 \predisplaypenalty\z@
 \postdisplaypenalty\z@
 %% amsmath
 \@ifpackageloaded{amsmath}{%
  \def\tagform@#1{\maketag@@@{[\ignorespaces#1\unskip\@@italiccorr]}}%
 }{}%
 %%
 %% cite.sty +Cite
 \@ifpackageloaded{cite}{%
  \renewcommand\citeform[1]{%(
   #1)}%
  %\def\@citess#1{\kern0pt\mbox{$\m@th^{\hbox{\tiny{#1}}}$}}%
  \def\@citess#1{\unskip\kern0pt\mbox{$\m@th^{\hbox{\OverciteFont{#1}}}$}}%
  \DeclareRobustCommand{\cite}{%
   \@ifnextchar[%]
    {\@tempswatrue\@citex}{\@tempswafalse\@citew}}%
  \DeclareRobustCommand{\Cite}{%
   \renewcommand\citeleft{}%
   \renewcommand\citeright{%(
    )}%
   \@ifnextchar[%]
    {\@tempswatrue\@citex}{\@tempswafalse\@citex[]}}%
  \renewcommand\citedash{--}%
 }{}%
 %%
 \@ifpackageloaded{nidanfloat}{%
  \renewcommand\dblbotfraction{0.9}% 0.5
  \setcounter{dblbotnumber}{4}% 2
 }{}%
}

\pagestyle{pjabheadings}
\pagenumbering{arabic}
\if@twoside
\else
  \raggedbottom
\fi
\if@twocolumn
  \twocolumn
  \sloppy
  \flushbottom
\else
  \onecolumn
\fi
\endinput
